module forward_conv_module_3 (clk, out0, in);
input clk; // clock
output [1:0] out0; // Module: 3
wire [4:0] sum0; // Maxval: 24
input [15:0] in; // Max value: 65535

sum_stage_3 inst_sum_3(clk, in, sum0);
correction_stage_3 inst_corr_3(clk, sum0, out0);
endmodule

module forward_conv_module_5 (clk, out0, in);
input clk; // clock
output [2:0] out0; // Module: 5
wire [5:0] sum0; // Maxval: 40
input [15:0] in; // Max value: 65535

sum_stage_5 inst_sum_5(clk, in, sum0);
correction_stage_5 inst_corr_5(clk, sum0, out0);
endmodule

module forward_conv_module_7 (clk, out0, in);
input clk; // clock
output [2:0] out0; // Module: 7
wire [5:0] sum0; // Maxval: 36
input [15:0] in; // Max value: 65535

sum_stage_7 inst_sum_7(clk, in, sum0);
correction_stage_7 inst_corr_7(clk, sum0, out0);
endmodule

module forward_conv_module_11 (clk, out0, in);
input clk; // clock
output [3:0] out0; // Module: 11
wire [6:0] sum0; // Maxval: 85
input [15:0] in; // Max value: 65535

sum_stage_11 inst_sum_11(clk, in, sum0);
correction_stage_11 inst_corr_11(clk, sum0, out0);
endmodule

module forward_conv_module_13 (clk, out0, in);
input clk; // clock
output [3:0] out0; // Module: 13
wire [6:0] sum0; // Maxval: 93
input [15:0] in; // Max value: 65535

sum_stage_13 inst_sum_13(clk, in, sum0);
correction_stage_13 inst_corr_13(clk, sum0, out0);
endmodule

module forward_conv_module_17 (clk, out0, in);
input clk; // clock
output [4:0] out0; // Module: 17
wire [7:0] sum0; // Maxval: 136
input [15:0] in; // Max value: 65535

sum_stage_17 inst_sum_17(clk, in, sum0);
correction_stage_17 inst_corr_17(clk, sum0, out0);
endmodule

module forward_conv_module_19 (clk, out0, in);
input clk; // clock
output [4:0] out0; // Module: 19
wire [7:0] sum0; // Maxval: 156
input [15:0] in; // Max value: 65535

sum_stage_19 inst_sum_19(clk, in, sum0);
correction_stage_19 inst_corr_19(clk, sum0, out0);
endmodule

module forward_conv_module_23 (clk, out0, in);
input clk; // clock
output [4:0] out0; // Module: 23
wire [6:0] sum0; // Maxval: 123
input [15:0] in; // Max value: 65535

sum_stage_23 inst_sum_23(clk, in, sum0);
correction_stage_23 inst_corr_23(clk, sum0, out0);
endmodule

module forward_conv_module_29 (clk, out0, in);
input clk; // clock
output [4:0] out0; // Module: 29
wire [7:0] sum0; // Maxval: 198
input [15:0] in; // Max value: 65535

sum_stage_29 inst_sum_29(clk, in, sum0);
correction_stage_29 inst_corr_29(clk, sum0, out0);
endmodule

module forward_conv_module_31 (clk, out0, in);
input clk; // clock
output [4:0] out0; // Module: 31
wire [6:0] sum0; // Maxval: 94
input [15:0] in; // Max value: 65535

sum_stage_31 inst_sum_31(clk, in, sum0);
correction_stage_31 inst_corr_31(clk, sum0, out0);
endmodule

module forward_conv_module_37 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 37
wire [8:0] sum0; // Maxval: 304
input [15:0] in; // Max value: 65535

sum_stage_37 inst_sum_37(clk, in, sum0);
correction_stage_37 inst_corr_37(clk, sum0, out0);
endmodule

module forward_conv_module_41 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 41
wire [8:0] sum0; // Maxval: 304
input [15:0] in; // Max value: 65535

sum_stage_41 inst_sum_41(clk, in, sum0);
correction_stage_41 inst_corr_41(clk, sum0, out0);
endmodule

module forward_conv_module_43 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 43
wire [8:0] sum0; // Maxval: 304
input [15:0] in; // Max value: 65535

sum_stage_43 inst_sum_43(clk, in, sum0);
correction_stage_43 inst_corr_43(clk, sum0, out0);
endmodule

module forward_conv_module_47 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 47
wire [8:0] sum0; // Maxval: 299
input [15:0] in; // Max value: 65535

sum_stage_47 inst_sum_47(clk, in, sum0);
correction_stage_47 inst_corr_47(clk, sum0, out0);
endmodule

module forward_conv_module_53 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 53
wire [8:0] sum0; // Maxval: 292
input [15:0] in; // Max value: 65535

sum_stage_53 inst_sum_53(clk, in, sum0);
correction_stage_53 inst_corr_53(clk, sum0, out0);
endmodule

module forward_conv_module_59 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 59
wire [8:0] sum0; // Maxval: 340
input [15:0] in; // Max value: 65535

sum_stage_59 inst_sum_59(clk, in, sum0);
correction_stage_59 inst_corr_59(clk, sum0, out0);
endmodule

module forward_conv_module_61 (clk, out0, in);
input clk; // clock
output [5:0] out0; // Module: 61
wire [8:0] sum0; // Maxval: 265
input [15:0] in; // Max value: 65535

sum_stage_61 inst_sum_61(clk, in, sum0);
correction_stage_61 inst_corr_61(clk, sum0, out0);
endmodule

module forward_conv_module_67 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 67
wire [8:0] sum0; // Maxval: 411
input [15:0] in; // Max value: 65535

sum_stage_67 inst_sum_67(clk, in, sum0);
correction_stage_67 inst_corr_67(clk, sum0, out0);
endmodule

module forward_conv_module_71 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 71
wire [8:0] sum0; // Maxval: 499
input [15:0] in; // Max value: 65535

sum_stage_71 inst_sum_71(clk, in, sum0);
correction_stage_71 inst_corr_71(clk, sum0, out0);
endmodule

module forward_conv_module_73 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 73
wire [8:0] sum0; // Maxval: 346
input [15:0] in; // Max value: 65535

sum_stage_73 inst_sum_73(clk, in, sum0);
correction_stage_73 inst_corr_73(clk, sum0, out0);
endmodule

module forward_conv_module_79 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 79
wire [9:0] sum0; // Maxval: 597
input [15:0] in; // Max value: 65535

sum_stage_79 inst_sum_79(clk, in, sum0);
correction_stage_79 inst_corr_79(clk, sum0, out0);
endmodule

module forward_conv_module_83 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 83
wire [8:0] sum0; // Maxval: 463
input [15:0] in; // Max value: 65535

sum_stage_83 inst_sum_83(clk, in, sum0);
correction_stage_83 inst_corr_83(clk, sum0, out0);
endmodule

module forward_conv_module_89 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 89
wire [8:0] sum0; // Maxval: 387
input [15:0] in; // Max value: 65535

sum_stage_89 inst_sum_89(clk, in, sum0);
correction_stage_89 inst_corr_89(clk, sum0, out0);
endmodule

module forward_conv_module_97 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 97
wire [9:0] sum0; // Maxval: 545
input [15:0] in; // Max value: 65535

sum_stage_97 inst_sum_97(clk, in, sum0);
correction_stage_97 inst_corr_97(clk, sum0, out0);
endmodule

module forward_conv_module_101 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 101
wire [8:0] sum0; // Maxval: 390
input [15:0] in; // Max value: 65535

sum_stage_101 inst_sum_101(clk, in, sum0);
correction_stage_101 inst_corr_101(clk, sum0, out0);
endmodule

module forward_conv_module_103 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 103
wire [9:0] sum0; // Maxval: 645
input [15:0] in; // Max value: 65535

sum_stage_103 inst_sum_103(clk, in, sum0);
correction_stage_103 inst_corr_103(clk, sum0, out0);
endmodule

module forward_conv_module_107 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 107
wire [8:0] sum0; // Maxval: 479
input [15:0] in; // Max value: 65535

sum_stage_107 inst_sum_107(clk, in, sum0);
correction_stage_107 inst_corr_107(clk, sum0, out0);
endmodule

module forward_conv_module_109 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 109
wire [9:0] sum0; // Maxval: 571
input [15:0] in; // Max value: 65535

sum_stage_109 inst_sum_109(clk, in, sum0);
correction_stage_109 inst_corr_109(clk, sum0, out0);
endmodule

module forward_conv_module_113 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 113
wire [9:0] sum0; // Maxval: 560
input [15:0] in; // Max value: 65535

sum_stage_113 inst_sum_113(clk, in, sum0);
correction_stage_113 inst_corr_113(clk, sum0, out0);
endmodule

module forward_conv_module_127 (clk, out0, in);
input clk; // clock
output [6:0] out0; // Module: 127
wire [8:0] sum0; // Maxval: 257
input [15:0] in; // Max value: 65535

sum_stage_127 inst_sum_127(clk, in, sum0);
correction_stage_127 inst_corr_127(clk, sum0, out0);
endmodule

module forward_conv_module_131 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 131
wire [9:0] sum0; // Maxval: 821
input [15:0] in; // Max value: 65535

sum_stage_131 inst_sum_131(clk, in, sum0);
correction_stage_131 inst_corr_131(clk, sum0, out0);
endmodule

module forward_conv_module_137 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 137
wire [9:0] sum0; // Maxval: 1008
input [15:0] in; // Max value: 65535

sum_stage_137 inst_sum_137(clk, in, sum0);
correction_stage_137 inst_corr_137(clk, sum0, out0);
endmodule

module forward_conv_module_139 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 139
wire [10:0] sum0; // Maxval: 1039
input [15:0] in; // Max value: 65535

sum_stage_139 inst_sum_139(clk, in, sum0);
correction_stage_139 inst_corr_139(clk, sum0, out0);
endmodule

module forward_conv_module_149 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 149
wire [10:0] sum0; // Maxval: 1167
input [15:0] in; // Max value: 65535

sum_stage_149 inst_sum_149(clk, in, sum0);
correction_stage_149 inst_corr_149(clk, sum0, out0);
endmodule

module forward_conv_module_151 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 151
wire [9:0] sum0; // Maxval: 756
input [15:0] in; // Max value: 65535

sum_stage_151 inst_sum_151(clk, in, sum0);
correction_stage_151 inst_corr_151(clk, sum0, out0);
endmodule

module forward_conv_module_157 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 157
wire [9:0] sum0; // Maxval: 694
input [15:0] in; // Max value: 65535

sum_stage_157 inst_sum_157(clk, in, sum0);
correction_stage_157 inst_corr_157(clk, sum0, out0);
endmodule

module forward_conv_module_163 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 163
wire [9:0] sum0; // Maxval: 661
input [15:0] in; // Max value: 65535

sum_stage_163 inst_sum_163(clk, in, sum0);
correction_stage_163 inst_corr_163(clk, sum0, out0);
endmodule

module forward_conv_module_167 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 167
wire [9:0] sum0; // Maxval: 572
input [15:0] in; // Max value: 65535

sum_stage_167 inst_sum_167(clk, in, sum0);
correction_stage_167 inst_corr_167(clk, sum0, out0);
endmodule

module forward_conv_module_173 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 173
wire [10:0] sum0; // Maxval: 1179
input [15:0] in; // Max value: 65535

sum_stage_173 inst_sum_173(clk, in, sum0);
correction_stage_173 inst_corr_173(clk, sum0, out0);
endmodule

module forward_conv_module_179 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 179
wire [10:0] sum0; // Maxval: 1095
input [15:0] in; // Max value: 65535

sum_stage_179 inst_sum_179(clk, in, sum0);
correction_stage_179 inst_corr_179(clk, sum0, out0);
endmodule

module forward_conv_module_181 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 181
wire [9:0] sum0; // Maxval: 918
input [15:0] in; // Max value: 65535

sum_stage_181 inst_sum_181(clk, in, sum0);
correction_stage_181 inst_corr_181(clk, sum0, out0);
endmodule

module forward_conv_module_191 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 191
wire [10:0] sum0; // Maxval: 1168
input [15:0] in; // Max value: 65535

sum_stage_191 inst_sum_191(clk, in, sum0);
correction_stage_191 inst_corr_191(clk, sum0, out0);
endmodule

module forward_conv_module_193 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 193
wire [10:0] sum0; // Maxval: 1073
input [15:0] in; // Max value: 65535

sum_stage_193 inst_sum_193(clk, in, sum0);
correction_stage_193 inst_corr_193(clk, sum0, out0);
endmodule

module forward_conv_module_197 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 197
wire [9:0] sum0; // Maxval: 919
input [15:0] in; // Max value: 65535

sum_stage_197 inst_sum_197(clk, in, sum0);
correction_stage_197 inst_corr_197(clk, sum0, out0);
endmodule

module forward_conv_module_199 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 199
wire [9:0] sum0; // Maxval: 860
input [15:0] in; // Max value: 65535

sum_stage_199 inst_sum_199(clk, in, sum0);
correction_stage_199 inst_corr_199(clk, sum0, out0);
endmodule

module forward_conv_module_211 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 211
wire [10:0] sum0; // Maxval: 1180
input [15:0] in; // Max value: 65535

sum_stage_211 inst_sum_211(clk, in, sum0);
correction_stage_211 inst_corr_211(clk, sum0, out0);
endmodule

module forward_conv_module_223 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 223
wire [10:0] sum0; // Maxval: 1088
input [15:0] in; // Max value: 65535

sum_stage_223 inst_sum_223(clk, in, sum0);
correction_stage_223 inst_corr_223(clk, sum0, out0);
endmodule

module forward_conv_module_227 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 227
wire [9:0] sum0; // Maxval: 613
input [15:0] in; // Max value: 65535

sum_stage_227 inst_sum_227(clk, in, sum0);
correction_stage_227 inst_corr_227(clk, sum0, out0);
endmodule

module forward_conv_module_229 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 229
wire [10:0] sum0; // Maxval: 1186
input [15:0] in; // Max value: 65535

sum_stage_229 inst_sum_229(clk, in, sum0);
correction_stage_229 inst_corr_229(clk, sum0, out0);
endmodule

module forward_conv_module_233 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 233
wire [9:0] sum0; // Maxval: 994
input [15:0] in; // Max value: 65535

sum_stage_233 inst_sum_233(clk, in, sum0);
correction_stage_233 inst_corr_233(clk, sum0, out0);
endmodule

module forward_conv_module_239 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 239
wire [9:0] sum0; // Maxval: 766
input [15:0] in; // Max value: 65535

sum_stage_239 inst_sum_239(clk, in, sum0);
correction_stage_239 inst_corr_239(clk, sum0, out0);
endmodule

module forward_conv_module_241 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 241
wire [10:0] sum0; // Maxval: 1429
input [15:0] in; // Max value: 65535

sum_stage_241 inst_sum_241(clk, in, sum0);
correction_stage_241 inst_corr_241(clk, sum0, out0);
endmodule

module forward_conv_module_251 (clk, out0, in);
input clk; // clock
output [7:0] out0; // Module: 251
wire [9:0] sum0; // Maxval: 777
input [15:0] in; // Max value: 65535

sum_stage_251 inst_sum_251(clk, in, sum0);
correction_stage_251 inst_corr_251(clk, sum0, out0);
endmodule

//_____________________________________________________________________





module sum_stage_3 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [4:0] out; // Max value: 24
	always @ (posedge clk)
	begin
		out = in[1:0] + in[2] + 2*in[3] + in[4] + 2*in[5] + in[6] + 2*in[7] + in[8] + 2*in[9] + in[10] + 2*in[11] + in[12] + 2*in[13] + in[14] + 2*in[15];
	end
endmodule

module correction_stage_3 (clk, in, out);
	input clk;
	input [4:0] in; // Max value: 24
	output reg [1:0] out; // Max value: 2
	wire [1:0] inter; // Max value: 2
	mod_3_24 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_3_24 (in, out);
	input [4:0] in;
	output reg [1:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 0;
		4: out = 1;
		5: out = 2;
		6: out = 0;
		7: out = 1;
		8: out = 2;
		9: out = 0;
		10: out = 1;
		11: out = 2;
		12: out = 0;
		13: out = 1;
		14: out = 2;
		15: out = 0;
		16: out = 1;
		17: out = 2;
		18: out = 0;
		19: out = 1;
		20: out = 2;
		21: out = 0;
		22: out = 1;
		23: out = 2;
		24: out = 0;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_5 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [5:0] out; // Max value: 40
	always @ (posedge clk)
	begin
		out = in[2:0] + 3*in[3] + in[4] + 2*in[5] + 4*in[6] + 3*in[7] + in[8] + 2*in[9] + 4*in[10] + 3*in[11] + in[12] + 2*in[13] + 4*in[14] + 3*in[15];
	end
endmodule

module correction_stage_5 (clk, in, out);
	input clk;
	input [5:0] in; // Max value: 40
	output reg [2:0] out; // Max value: 4
	wire [2:0] inter; // Max value: 4
	mod_5_40 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_5_40 (in, out);
	input [5:0] in;
	output reg [2:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 0;
		6: out = 1;
		7: out = 2;
		8: out = 3;
		9: out = 4;
		10: out = 0;
		11: out = 1;
		12: out = 2;
		13: out = 3;
		14: out = 4;
		15: out = 0;
		16: out = 1;
		17: out = 2;
		18: out = 3;
		19: out = 4;
		20: out = 0;
		21: out = 1;
		22: out = 2;
		23: out = 3;
		24: out = 4;
		25: out = 0;
		26: out = 1;
		27: out = 2;
		28: out = 3;
		29: out = 4;
		30: out = 0;
		31: out = 1;
		32: out = 2;
		33: out = 3;
		34: out = 4;
		35: out = 0;
		36: out = 1;
		37: out = 2;
		38: out = 3;
		39: out = 4;
		40: out = 0;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_7 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [5:0] out; // Max value: 36
	always @ (posedge clk)
	begin
		out = in[2:0] + in[3] + 2*in[4] + 4*in[5] + in[6] + 2*in[7] + 4*in[8] + in[9] + 2*in[10] + 4*in[11] + in[12] + 2*in[13] + 4*in[14] + in[15];
	end
endmodule

module correction_stage_7 (clk, in, out);
	input clk;
	input [5:0] in; // Max value: 36
	output reg [2:0] out; // Max value: 6
	wire [2:0] inter; // Max value: 6
	mod_7_36 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_7_36 (in, out);
	input [5:0] in;
	output reg [2:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 0;
		8: out = 1;
		9: out = 2;
		10: out = 3;
		11: out = 4;
		12: out = 5;
		13: out = 6;
		14: out = 0;
		15: out = 1;
		16: out = 2;
		17: out = 3;
		18: out = 4;
		19: out = 5;
		20: out = 6;
		21: out = 0;
		22: out = 1;
		23: out = 2;
		24: out = 3;
		25: out = 4;
		26: out = 5;
		27: out = 6;
		28: out = 0;
		29: out = 1;
		30: out = 2;
		31: out = 3;
		32: out = 4;
		33: out = 5;
		34: out = 6;
		35: out = 0;
		36: out = 1;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_11 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [6:0] out; // Max value: 85
	always @ (posedge clk)
	begin
		out = in[3:0] + 5*in[4] + 10*in[5] + 9*in[6] + 7*in[7] + 3*in[8] + 6*in[9] + in[10] + 2*in[11] + 4*in[12] + 8*in[13] + 5*in[14] + 10*in[15];
	end
endmodule

module correction_stage_11 (clk, in, out);
	input clk;
	input [6:0] in; // Max value: 85
	output reg [3:0] out; // Max value: 10
	wire [3:0] inter; // Max value: 10
	mod_11_85 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_11_85 (in, out);
	input [6:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 7;
		8: out = 8;
		9: out = 9;
		10: out = 10;
		11: out = 0;
		12: out = 1;
		13: out = 2;
		14: out = 3;
		15: out = 4;
		16: out = 5;
		17: out = 6;
		18: out = 7;
		19: out = 8;
		20: out = 9;
		21: out = 10;
		22: out = 0;
		23: out = 1;
		24: out = 2;
		25: out = 3;
		26: out = 4;
		27: out = 5;
		28: out = 6;
		29: out = 7;
		30: out = 8;
		31: out = 9;
		32: out = 10;
		33: out = 0;
		34: out = 1;
		35: out = 2;
		36: out = 3;
		37: out = 4;
		38: out = 5;
		39: out = 6;
		40: out = 7;
		41: out = 8;
		42: out = 9;
		43: out = 10;
		44: out = 0;
		45: out = 1;
		46: out = 2;
		47: out = 3;
		48: out = 4;
		49: out = 5;
		50: out = 6;
		51: out = 7;
		52: out = 8;
		53: out = 9;
		54: out = 10;
		55: out = 0;
		56: out = 1;
		57: out = 2;
		58: out = 3;
		59: out = 4;
		60: out = 5;
		61: out = 6;
		62: out = 7;
		63: out = 8;
		64: out = 9;
		65: out = 10;
		66: out = 0;
		67: out = 1;
		68: out = 2;
		69: out = 3;
		70: out = 4;
		71: out = 5;
		72: out = 6;
		73: out = 7;
		74: out = 8;
		75: out = 9;
		76: out = 10;
		77: out = 0;
		78: out = 1;
		79: out = 2;
		80: out = 3;
		81: out = 4;
		82: out = 5;
		83: out = 6;
		84: out = 7;
		85: out = 8;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_13 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [6:0] out; // Max value: 93
	always @ (posedge clk)
	begin
		out = in[3:0] + 3*in[4] + 6*in[5] + 12*in[6] + 11*in[7] + 9*in[8] + 5*in[9] + 10*in[10] + 7*in[11] + in[12] + 2*in[13] + 4*in[14] + 8*in[15];
	end
endmodule

module correction_stage_13 (clk, in, out);
	input clk;
	input [6:0] in; // Max value: 93
	output reg [3:0] out; // Max value: 12
	wire [3:0] inter; // Max value: 12
	mod_13_93 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_13_93 (in, out);
	input [6:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 7;
		8: out = 8;
		9: out = 9;
		10: out = 10;
		11: out = 11;
		12: out = 12;
		13: out = 0;
		14: out = 1;
		15: out = 2;
		16: out = 3;
		17: out = 4;
		18: out = 5;
		19: out = 6;
		20: out = 7;
		21: out = 8;
		22: out = 9;
		23: out = 10;
		24: out = 11;
		25: out = 12;
		26: out = 0;
		27: out = 1;
		28: out = 2;
		29: out = 3;
		30: out = 4;
		31: out = 5;
		32: out = 6;
		33: out = 7;
		34: out = 8;
		35: out = 9;
		36: out = 10;
		37: out = 11;
		38: out = 12;
		39: out = 0;
		40: out = 1;
		41: out = 2;
		42: out = 3;
		43: out = 4;
		44: out = 5;
		45: out = 6;
		46: out = 7;
		47: out = 8;
		48: out = 9;
		49: out = 10;
		50: out = 11;
		51: out = 12;
		52: out = 0;
		53: out = 1;
		54: out = 2;
		55: out = 3;
		56: out = 4;
		57: out = 5;
		58: out = 6;
		59: out = 7;
		60: out = 8;
		61: out = 9;
		62: out = 10;
		63: out = 11;
		64: out = 12;
		65: out = 0;
		66: out = 1;
		67: out = 2;
		68: out = 3;
		69: out = 4;
		70: out = 5;
		71: out = 6;
		72: out = 7;
		73: out = 8;
		74: out = 9;
		75: out = 10;
		76: out = 11;
		77: out = 12;
		78: out = 0;
		79: out = 1;
		80: out = 2;
		81: out = 3;
		82: out = 4;
		83: out = 5;
		84: out = 6;
		85: out = 7;
		86: out = 8;
		87: out = 9;
		88: out = 10;
		89: out = 11;
		90: out = 12;
		91: out = 0;
		92: out = 1;
		93: out = 2;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_17 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [7:0] out; // Max value: 136
	always @ (posedge clk)
	begin
		out = in[4:0] + 15*in[5] + 13*in[6] + 9*in[7] + in[8] + 2*in[9] + 4*in[10] + 8*in[11] + 16*in[12] + 15*in[13] + 13*in[14] + 9*in[15];
	end
endmodule

module correction_stage_17 (clk, in, out);
	input clk;
	input [7:0] in; // Max value: 136
	output reg [4:0] out; // Max value: 16
	wire [4:0] inter; // Max value: 16
	mod_17_136 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_17_136 (in, out);
	input [7:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else if (in < 6'd51)
		begin
			out = in - 6'd34;
		end
		else if (in < 7'd68)
		begin
			out = in - 6'd51;
		end
		else if (in < 7'd85)
		begin
			out = in - 7'd68;
		end
		else if (in < 7'd102)
		begin
			out = in - 7'd85;
		end
		else if (in < 7'd119)
		begin
			out = in - 7'd102;
		end
		else if (in < 8'd136)
		begin
			out = in - 7'd119;
		end
		else
		begin
			out = in - 8'd136;
		end
	end
endmodule

module sum_stage_19 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [7:0] out; // Max value: 156
	always @ (posedge clk)
	begin
		out = in[4:0] + 13*in[5] + 7*in[6] + 14*in[7] + 9*in[8] + 18*in[9] + 17*in[10] + 15*in[11] + 11*in[12] + 3*in[13] + 6*in[14] + 12*in[15];
	end
endmodule

module correction_stage_19 (clk, in, out);
	input clk;
	input [7:0] in; // Max value: 156
	output reg [4:0] out; // Max value: 18
	wire [4:0] inter; // Max value: 18
	mod_19_156 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_19_156 (in, out);
	input [7:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd19)
		begin
			out = in;
		end
		else if (in < 6'd38)
		begin
			out = in - 5'd19;
		end
		else if (in < 6'd57)
		begin
			out = in - 6'd38;
		end
		else if (in < 7'd76)
		begin
			out = in - 6'd57;
		end
		else if (in < 7'd95)
		begin
			out = in - 7'd76;
		end
		else if (in < 7'd114)
		begin
			out = in - 7'd95;
		end
		else if (in < 8'd133)
		begin
			out = in - 7'd114;
		end
		else if (in < 8'd152)
		begin
			out = in - 8'd133;
		end
		else
		begin
			out = in - 8'd152;
		end
	end
endmodule

module sum_stage_23 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [6:0] out; // Max value: 123
	always @ (posedge clk)
	begin
		out = in[4:0] + 9*in[5] + 18*in[6] + 13*in[7] + 3*in[8] + 6*in[9] + 12*in[10] + in[11] + 2*in[12] + 4*in[13] + 8*in[14] + 16*in[15];
	end
endmodule

module correction_stage_23 (clk, in, out);
	input clk;
	input [6:0] in; // Max value: 123
	output reg [4:0] out; // Max value: 22
	wire [4:0] inter; // Max value: 22
	mod_23_123 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_23_123 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else if (in < 7'd69)
		begin
			out = in - 6'd46;
		end
		else if (in < 7'd92)
		begin
			out = in - 7'd69;
		end
		else if (in < 7'd115)
		begin
			out = in - 7'd92;
		end
		else
		begin
			out = in - 7'd115;
		end
	end
endmodule

module sum_stage_29 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [7:0] out; // Max value: 198
	always @ (posedge clk)
	begin
		out = in[4:0] + 3*in[5] + 6*in[6] + 12*in[7] + 24*in[8] + 19*in[9] + 9*in[10] + 18*in[11] + 7*in[12] + 14*in[13] + 28*in[14] + 27*in[15];
	end
endmodule

module correction_stage_29 (clk, in, out);
	input clk;
	input [7:0] in; // Max value: 198
	output reg [4:0] out; // Max value: 28
	wire [4:0] inter; // Max value: 28
	mod_29_198 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_29_198 (in, out);
	input [7:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd29)
		begin
			out = in;
		end
		else if (in < 6'd58)
		begin
			out = in - 5'd29;
		end
		else if (in < 7'd87)
		begin
			out = in - 6'd58;
		end
		else if (in < 7'd116)
		begin
			out = in - 7'd87;
		end
		else if (in < 8'd145)
		begin
			out = in - 7'd116;
		end
		else if (in < 8'd174)
		begin
			out = in - 8'd145;
		end
		else
		begin
			out = in - 8'd174;
		end
	end
endmodule

module sum_stage_31 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [6:0] out; // Max value: 94
	always @ (posedge clk)
	begin
		out = in[4:0] + in[5] + 2*in[6] + 4*in[7] + 8*in[8] + 16*in[9] + in[10] + 2*in[11] + 4*in[12] + 8*in[13] + 16*in[14] + in[15];
	end
endmodule

module correction_stage_31 (clk, in, out);
	input clk;
	input [6:0] in; // Max value: 94
	output reg [4:0] out; // Max value: 30
	wire [4:0] inter; // Max value: 30
	mod_31_94 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_31_94 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
	// we have small max value so we can use table here
	case (in)
		0: out = 0;
		1: out = 1;
		2: out = 2;
		3: out = 3;
		4: out = 4;
		5: out = 5;
		6: out = 6;
		7: out = 7;
		8: out = 8;
		9: out = 9;
		10: out = 10;
		11: out = 11;
		12: out = 12;
		13: out = 13;
		14: out = 14;
		15: out = 15;
		16: out = 16;
		17: out = 17;
		18: out = 18;
		19: out = 19;
		20: out = 20;
		21: out = 21;
		22: out = 22;
		23: out = 23;
		24: out = 24;
		25: out = 25;
		26: out = 26;
		27: out = 27;
		28: out = 28;
		29: out = 29;
		30: out = 30;
		31: out = 0;
		32: out = 1;
		33: out = 2;
		34: out = 3;
		35: out = 4;
		36: out = 5;
		37: out = 6;
		38: out = 7;
		39: out = 8;
		40: out = 9;
		41: out = 10;
		42: out = 11;
		43: out = 12;
		44: out = 13;
		45: out = 14;
		46: out = 15;
		47: out = 16;
		48: out = 17;
		49: out = 18;
		50: out = 19;
		51: out = 20;
		52: out = 21;
		53: out = 22;
		54: out = 23;
		55: out = 24;
		56: out = 25;
		57: out = 26;
		58: out = 27;
		59: out = 28;
		60: out = 29;
		61: out = 30;
		62: out = 0;
		63: out = 1;
		64: out = 2;
		65: out = 3;
		66: out = 4;
		67: out = 5;
		68: out = 6;
		69: out = 7;
		70: out = 8;
		71: out = 9;
		72: out = 10;
		73: out = 11;
		74: out = 12;
		75: out = 13;
		76: out = 14;
		77: out = 15;
		78: out = 16;
		79: out = 17;
		80: out = 18;
		81: out = 19;
		82: out = 20;
		83: out = 21;
		84: out = 22;
		85: out = 23;
		86: out = 24;
		87: out = 25;
		88: out = 26;
		89: out = 27;
		90: out = 28;
		91: out = 29;
		92: out = 30;
		93: out = 0;
		94: out = 1;
		default: out = 0;
	endcase
	end
endmodule

module sum_stage_37 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 304
	always @ (posedge clk)
	begin
		out = in[5:0] + 27*in[6] + 17*in[7] + 34*in[8] + 31*in[9] + 25*in[10] + 13*in[11] + 26*in[12] + 15*in[13] + 30*in[14] + 23*in[15];
	end
endmodule

module correction_stage_37 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 304
	output reg [5:0] out; // Max value: 36
	wire [5:0] inter; // Max value: 36
	mod_37_304 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_37_304 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd37)
		begin
			out = in;
		end
		else if (in < 7'd74)
		begin
			out = in - 6'd37;
		end
		else if (in < 7'd111)
		begin
			out = in - 7'd74;
		end
		else if (in < 8'd148)
		begin
			out = in - 7'd111;
		end
		else if (in < 8'd185)
		begin
			out = in - 8'd148;
		end
		else if (in < 8'd222)
		begin
			out = in - 8'd185;
		end
		else if (in < 9'd259)
		begin
			out = in - 8'd222;
		end
		else if (in < 9'd296)
		begin
			out = in - 9'd259;
		end
		else
		begin
			out = in - 9'd296;
		end
	end
endmodule

module sum_stage_41 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 304
	always @ (posedge clk)
	begin
		out = in[5:0] + 23*in[6] + 5*in[7] + 10*in[8] + 20*in[9] + 40*in[10] + 39*in[11] + 37*in[12] + 33*in[13] + 25*in[14] + 9*in[15];
	end
endmodule

module correction_stage_41 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 304
	output reg [5:0] out; // Max value: 40
	wire [5:0] inter; // Max value: 40
	mod_41_304 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_41_304 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd41)
		begin
			out = in;
		end
		else if (in < 7'd82)
		begin
			out = in - 6'd41;
		end
		else if (in < 7'd123)
		begin
			out = in - 7'd82;
		end
		else if (in < 8'd164)
		begin
			out = in - 7'd123;
		end
		else if (in < 8'd205)
		begin
			out = in - 8'd164;
		end
		else if (in < 8'd246)
		begin
			out = in - 8'd205;
		end
		else if (in < 9'd287)
		begin
			out = in - 8'd246;
		end
		else
		begin
			out = in - 9'd287;
		end
	end
endmodule

module sum_stage_43 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 304
	always @ (posedge clk)
	begin
		out = in[5:0] + 21*in[6] + 42*in[7] + 41*in[8] + 39*in[9] + 35*in[10] + 27*in[11] + 11*in[12] + 22*in[13] + in[14] + 2*in[15];
	end
endmodule

module correction_stage_43 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 304
	output reg [5:0] out; // Max value: 42
	wire [5:0] inter; // Max value: 42
	mod_43_304 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_43_304 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd43)
		begin
			out = in;
		end
		else if (in < 7'd86)
		begin
			out = in - 6'd43;
		end
		else if (in < 8'd129)
		begin
			out = in - 7'd86;
		end
		else if (in < 8'd172)
		begin
			out = in - 8'd129;
		end
		else if (in < 8'd215)
		begin
			out = in - 8'd172;
		end
		else if (in < 9'd258)
		begin
			out = in - 8'd215;
		end
		else if (in < 9'd301)
		begin
			out = in - 9'd258;
		end
		else
		begin
			out = in - 9'd301;
		end
	end
endmodule

module sum_stage_47 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 299
	always @ (posedge clk)
	begin
		out = in[5:0] + 17*in[6] + 34*in[7] + 21*in[8] + 42*in[9] + 37*in[10] + 27*in[11] + 7*in[12] + 14*in[13] + 28*in[14] + 9*in[15];
	end
endmodule

module correction_stage_47 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 299
	output reg [5:0] out; // Max value: 46
	wire [5:0] inter; // Max value: 46
	mod_47_299 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_47_299 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd47)
		begin
			out = in;
		end
		else if (in < 7'd94)
		begin
			out = in - 6'd47;
		end
		else if (in < 8'd141)
		begin
			out = in - 7'd94;
		end
		else if (in < 8'd188)
		begin
			out = in - 8'd141;
		end
		else if (in < 8'd235)
		begin
			out = in - 8'd188;
		end
		else if (in < 9'd282)
		begin
			out = in - 8'd235;
		end
		else
		begin
			out = in - 9'd282;
		end
	end
endmodule

module sum_stage_53 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 292
	always @ (posedge clk)
	begin
		out = in[5:0] + 11*in[6] + 22*in[7] + 44*in[8] + 35*in[9] + 17*in[10] + 34*in[11] + 15*in[12] + 30*in[13] + 7*in[14] + 14*in[15];
	end
endmodule

module correction_stage_53 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 292
	output reg [5:0] out; // Max value: 52
	wire [5:0] inter; // Max value: 52
	mod_53_292 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_53_292 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd53)
		begin
			out = in;
		end
		else if (in < 7'd106)
		begin
			out = in - 6'd53;
		end
		else if (in < 8'd159)
		begin
			out = in - 7'd106;
		end
		else if (in < 8'd212)
		begin
			out = in - 8'd159;
		end
		else if (in < 9'd265)
		begin
			out = in - 8'd212;
		end
		else
		begin
			out = in - 9'd265;
		end
	end
endmodule

module sum_stage_59 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 340
	always @ (posedge clk)
	begin
		out = in[5:0] + 5*in[6] + 10*in[7] + 20*in[8] + 40*in[9] + 21*in[10] + 42*in[11] + 25*in[12] + 50*in[13] + 41*in[14] + 23*in[15];
	end
endmodule

module correction_stage_59 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 340
	output reg [5:0] out; // Max value: 58
	wire [5:0] inter; // Max value: 58
	mod_59_340 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_59_340 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd59)
		begin
			out = in;
		end
		else if (in < 7'd118)
		begin
			out = in - 6'd59;
		end
		else if (in < 8'd177)
		begin
			out = in - 7'd118;
		end
		else if (in < 8'd236)
		begin
			out = in - 8'd177;
		end
		else if (in < 9'd295)
		begin
			out = in - 8'd236;
		end
		else
		begin
			out = in - 9'd295;
		end
	end
endmodule

module sum_stage_61 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 265
	always @ (posedge clk)
	begin
		out = in[5:0] + 3*in[6] + 6*in[7] + 12*in[8] + 24*in[9] + 48*in[10] + 35*in[11] + 9*in[12] + 18*in[13] + 36*in[14] + 11*in[15];
	end
endmodule

module correction_stage_61 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 265
	output reg [5:0] out; // Max value: 60
	wire [5:0] inter; // Max value: 60
	mod_61_265 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_61_265 (in, out);
	input [8:0] in;
	output reg [5:0] out;
	always @ (in)
	begin
		if (in < 6'd61)
		begin
			out = in;
		end
		else if (in < 7'd122)
		begin
			out = in - 6'd61;
		end
		else if (in < 8'd183)
		begin
			out = in - 7'd122;
		end
		else if (in < 8'd244)
		begin
			out = in - 8'd183;
		end
		else
		begin
			out = in - 8'd244;
		end
	end
endmodule

module sum_stage_67 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 411
	always @ (posedge clk)
	begin
		out = in[6:0] + 61*in[7] + 55*in[8] + 43*in[9] + 19*in[10] + 38*in[11] + 9*in[12] + 18*in[13] + 36*in[14] + 5*in[15];
	end
endmodule

module correction_stage_67 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 411
	output reg [6:0] out; // Max value: 66
	wire [6:0] inter; // Max value: 66
	mod_67_411 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_67_411 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd67)
		begin
			out = in;
		end
		else if (in < 8'd134)
		begin
			out = in - 7'd67;
		end
		else if (in < 8'd201)
		begin
			out = in - 8'd134;
		end
		else if (in < 9'd268)
		begin
			out = in - 8'd201;
		end
		else if (in < 9'd335)
		begin
			out = in - 9'd268;
		end
		else if (in < 9'd402)
		begin
			out = in - 9'd335;
		end
		else
		begin
			out = in - 9'd402;
		end
	end
endmodule

module sum_stage_71 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 499
	always @ (posedge clk)
	begin
		out = in[6:0] + 57*in[7] + 43*in[8] + 15*in[9] + 30*in[10] + 60*in[11] + 49*in[12] + 27*in[13] + 54*in[14] + 37*in[15];
	end
endmodule

module correction_stage_71 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 499
	output reg [6:0] out; // Max value: 70
	wire [6:0] inter; // Max value: 70
	mod_71_499 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_71_499 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd71)
		begin
			out = in;
		end
		else if (in < 8'd142)
		begin
			out = in - 7'd71;
		end
		else if (in < 8'd213)
		begin
			out = in - 8'd142;
		end
		else if (in < 9'd284)
		begin
			out = in - 8'd213;
		end
		else if (in < 9'd355)
		begin
			out = in - 9'd284;
		end
		else if (in < 9'd426)
		begin
			out = in - 9'd355;
		end
		else if (in < 9'd497)
		begin
			out = in - 9'd426;
		end
		else
		begin
			out = in - 9'd497;
		end
	end
endmodule

module sum_stage_73 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 346
	always @ (posedge clk)
	begin
		out = in[6:0] + 55*in[7] + 37*in[8] + in[9] + 2*in[10] + 4*in[11] + 8*in[12] + 16*in[13] + 32*in[14] + 64*in[15];
	end
endmodule

module correction_stage_73 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 346
	output reg [6:0] out; // Max value: 72
	wire [6:0] inter; // Max value: 72
	mod_73_346 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_73_346 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd73)
		begin
			out = in;
		end
		else if (in < 8'd146)
		begin
			out = in - 7'd73;
		end
		else if (in < 8'd219)
		begin
			out = in - 8'd146;
		end
		else if (in < 9'd292)
		begin
			out = in - 8'd219;
		end
		else
		begin
			out = in - 9'd292;
		end
	end
endmodule

module sum_stage_79 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 597
	always @ (posedge clk)
	begin
		out = in[6:0] + 49*in[7] + 19*in[8] + 38*in[9] + 76*in[10] + 73*in[11] + 67*in[12] + 55*in[13] + 31*in[14] + 62*in[15];
	end
endmodule

module correction_stage_79 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 597
	output reg [6:0] out; // Max value: 78
	wire [6:0] inter; // Max value: 78
	mod_79_597 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_79_597 (in, out);
	input [9:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd79)
		begin
			out = in;
		end
		else if (in < 8'd158)
		begin
			out = in - 7'd79;
		end
		else if (in < 8'd237)
		begin
			out = in - 8'd158;
		end
		else if (in < 9'd316)
		begin
			out = in - 8'd237;
		end
		else if (in < 9'd395)
		begin
			out = in - 9'd316;
		end
		else if (in < 9'd474)
		begin
			out = in - 9'd395;
		end
		else if (in < 10'd553)
		begin
			out = in - 9'd474;
		end
		else
		begin
			out = in - 10'd553;
		end
	end
endmodule

module sum_stage_83 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 463
	always @ (posedge clk)
	begin
		out = in[6:0] + 45*in[7] + 7*in[8] + 14*in[9] + 28*in[10] + 56*in[11] + 29*in[12] + 58*in[13] + 33*in[14] + 66*in[15];
	end
endmodule

module correction_stage_83 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 463
	output reg [6:0] out; // Max value: 82
	wire [6:0] inter; // Max value: 82
	mod_83_463 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_83_463 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd83)
		begin
			out = in;
		end
		else if (in < 8'd166)
		begin
			out = in - 7'd83;
		end
		else if (in < 8'd249)
		begin
			out = in - 8'd166;
		end
		else if (in < 9'd332)
		begin
			out = in - 8'd249;
		end
		else if (in < 9'd415)
		begin
			out = in - 9'd332;
		end
		else
		begin
			out = in - 9'd415;
		end
	end
endmodule

module sum_stage_89 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 387
	always @ (posedge clk)
	begin
		out = in[6:0] + 39*in[7] + 78*in[8] + 67*in[9] + 45*in[10] + in[11] + 2*in[12] + 4*in[13] + 8*in[14] + 16*in[15];
	end
endmodule

module correction_stage_89 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 387
	output reg [6:0] out; // Max value: 88
	wire [6:0] inter; // Max value: 88
	mod_89_387 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_89_387 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd89)
		begin
			out = in;
		end
		else if (in < 8'd178)
		begin
			out = in - 7'd89;
		end
		else if (in < 9'd267)
		begin
			out = in - 8'd178;
		end
		else if (in < 9'd356)
		begin
			out = in - 9'd267;
		end
		else
		begin
			out = in - 9'd356;
		end
	end
endmodule

module sum_stage_97 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 545
	always @ (posedge clk)
	begin
		out = in[6:0] + 31*in[7] + 62*in[8] + 27*in[9] + 54*in[10] + 11*in[11] + 22*in[12] + 44*in[13] + 88*in[14] + 79*in[15];
	end
endmodule

module correction_stage_97 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 545
	output reg [6:0] out; // Max value: 96
	wire [6:0] inter; // Max value: 96
	mod_97_545 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_97_545 (in, out);
	input [9:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd97)
		begin
			out = in;
		end
		else if (in < 8'd194)
		begin
			out = in - 7'd97;
		end
		else if (in < 9'd291)
		begin
			out = in - 8'd194;
		end
		else if (in < 9'd388)
		begin
			out = in - 9'd291;
		end
		else if (in < 9'd485)
		begin
			out = in - 9'd388;
		end
		else
		begin
			out = in - 9'd485;
		end
	end
endmodule

module sum_stage_101 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 390
	always @ (posedge clk)
	begin
		out = in[6:0] + 27*in[7] + 54*in[8] + 7*in[9] + 14*in[10] + 28*in[11] + 56*in[12] + 11*in[13] + 22*in[14] + 44*in[15];
	end
endmodule

module correction_stage_101 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 390
	output reg [6:0] out; // Max value: 100
	wire [6:0] inter; // Max value: 100
	mod_101_390 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_101_390 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd101)
		begin
			out = in;
		end
		else if (in < 8'd202)
		begin
			out = in - 7'd101;
		end
		else if (in < 9'd303)
		begin
			out = in - 8'd202;
		end
		else
		begin
			out = in - 9'd303;
		end
	end
endmodule

module sum_stage_103 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 645
	always @ (posedge clk)
	begin
		out = in[6:0] + 25*in[7] + 50*in[8] + 100*in[9] + 97*in[10] + 91*in[11] + 79*in[12] + 55*in[13] + 7*in[14] + 14*in[15];
	end
endmodule

module correction_stage_103 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 645
	output reg [6:0] out; // Max value: 102
	wire [6:0] inter; // Max value: 102
	mod_103_645 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_103_645 (in, out);
	input [9:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd103)
		begin
			out = in;
		end
		else if (in < 8'd206)
		begin
			out = in - 7'd103;
		end
		else if (in < 9'd309)
		begin
			out = in - 8'd206;
		end
		else if (in < 9'd412)
		begin
			out = in - 9'd309;
		end
		else if (in < 10'd515)
		begin
			out = in - 9'd412;
		end
		else if (in < 10'd618)
		begin
			out = in - 10'd515;
		end
		else
		begin
			out = in - 10'd618;
		end
	end
endmodule

module sum_stage_107 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 479
	always @ (posedge clk)
	begin
		out = in[6:0] + 21*in[7] + 42*in[8] + 84*in[9] + 61*in[10] + 15*in[11] + 30*in[12] + 60*in[13] + 13*in[14] + 26*in[15];
	end
endmodule

module correction_stage_107 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 479
	output reg [6:0] out; // Max value: 106
	wire [6:0] inter; // Max value: 106
	mod_107_479 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_107_479 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd107)
		begin
			out = in;
		end
		else if (in < 8'd214)
		begin
			out = in - 7'd107;
		end
		else if (in < 9'd321)
		begin
			out = in - 8'd214;
		end
		else if (in < 9'd428)
		begin
			out = in - 9'd321;
		end
		else
		begin
			out = in - 9'd428;
		end
	end
endmodule

module sum_stage_109 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 571
	always @ (posedge clk)
	begin
		out = in[6:0] + 19*in[7] + 38*in[8] + 76*in[9] + 43*in[10] + 86*in[11] + 63*in[12] + 17*in[13] + 34*in[14] + 68*in[15];
	end
endmodule

module correction_stage_109 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 571
	output reg [6:0] out; // Max value: 108
	wire [6:0] inter; // Max value: 108
	mod_109_571 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_109_571 (in, out);
	input [9:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd109)
		begin
			out = in;
		end
		else if (in < 8'd218)
		begin
			out = in - 7'd109;
		end
		else if (in < 9'd327)
		begin
			out = in - 8'd218;
		end
		else if (in < 9'd436)
		begin
			out = in - 9'd327;
		end
		else if (in < 10'd545)
		begin
			out = in - 9'd436;
		end
		else
		begin
			out = in - 10'd545;
		end
	end
endmodule

module sum_stage_113 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 560
	always @ (posedge clk)
	begin
		out = in[6:0] + 15*in[7] + 30*in[8] + 60*in[9] + 7*in[10] + 14*in[11] + 28*in[12] + 56*in[13] + 112*in[14] + 111*in[15];
	end
endmodule

module correction_stage_113 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 560
	output reg [6:0] out; // Max value: 112
	wire [6:0] inter; // Max value: 112
	mod_113_560 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_113_560 (in, out);
	input [9:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd113)
		begin
			out = in;
		end
		else if (in < 8'd226)
		begin
			out = in - 7'd113;
		end
		else if (in < 9'd339)
		begin
			out = in - 8'd226;
		end
		else if (in < 9'd452)
		begin
			out = in - 9'd339;
		end
		else
		begin
			out = in - 9'd452;
		end
	end
endmodule

module sum_stage_127 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [8:0] out; // Max value: 257
	always @ (posedge clk)
	begin
		out = in[6:0] + in[7] + 2*in[8] + 4*in[9] + 8*in[10] + 16*in[11] + 32*in[12] + 64*in[13] + in[14] + 2*in[15];
	end
endmodule

module correction_stage_127 (clk, in, out);
	input clk;
	input [8:0] in; // Max value: 257
	output reg [6:0] out; // Max value: 126
	wire [6:0] inter; // Max value: 126
	mod_127_257 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_127_257 (in, out);
	input [8:0] in;
	output reg [6:0] out;
	always @ (in)
	begin
		if (in < 7'd127)
		begin
			out = in;
		end
		else if (in < 8'd254)
		begin
			out = in - 7'd127;
		end
		else
		begin
			out = in - 8'd254;
		end
	end
endmodule

module sum_stage_131 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 821
	always @ (posedge clk)
	begin
		out = in[7:0] + 125*in[8] + 119*in[9] + 107*in[10] + 83*in[11] + 35*in[12] + 70*in[13] + 9*in[14] + 18*in[15];
	end
endmodule

module correction_stage_131 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 821
	output reg [7:0] out; // Max value: 130
	wire [7:0] inter; // Max value: 130
	mod_131_821 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_131_821 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd131)
		begin
			out = in;
		end
		else if (in < 9'd262)
		begin
			out = in - 8'd131;
		end
		else if (in < 9'd393)
		begin
			out = in - 9'd262;
		end
		else if (in < 10'd524)
		begin
			out = in - 9'd393;
		end
		else if (in < 10'd655)
		begin
			out = in - 10'd524;
		end
		else if (in < 10'd786)
		begin
			out = in - 10'd655;
		end
		else
		begin
			out = in - 10'd786;
		end
	end
endmodule

module sum_stage_137 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 1008
	always @ (posedge clk)
	begin
		out = in[7:0] + 119*in[8] + 101*in[9] + 65*in[10] + 130*in[11] + 123*in[12] + 109*in[13] + 81*in[14] + 25*in[15];
	end
endmodule

module correction_stage_137 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 1008
	output reg [7:0] out; // Max value: 136
	wire [7:0] inter; // Max value: 136
	mod_137_1008 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_137_1008 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd137)
		begin
			out = in;
		end
		else if (in < 9'd274)
		begin
			out = in - 8'd137;
		end
		else if (in < 9'd411)
		begin
			out = in - 9'd274;
		end
		else if (in < 10'd548)
		begin
			out = in - 9'd411;
		end
		else if (in < 10'd685)
		begin
			out = in - 10'd548;
		end
		else if (in < 10'd822)
		begin
			out = in - 10'd685;
		end
		else if (in < 10'd959)
		begin
			out = in - 10'd822;
		end
		else
		begin
			out = in - 10'd959;
		end
	end
endmodule

module sum_stage_139 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1039
	always @ (posedge clk)
	begin
		out = in[7:0] + 117*in[8] + 95*in[9] + 51*in[10] + 102*in[11] + 65*in[12] + 130*in[13] + 121*in[14] + 103*in[15];
	end
endmodule

module correction_stage_139 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1039
	output reg [7:0] out; // Max value: 138
	wire [7:0] inter; // Max value: 138
	mod_139_1039 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_139_1039 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd139)
		begin
			out = in;
		end
		else if (in < 9'd278)
		begin
			out = in - 8'd139;
		end
		else if (in < 9'd417)
		begin
			out = in - 9'd278;
		end
		else if (in < 10'd556)
		begin
			out = in - 9'd417;
		end
		else if (in < 10'd695)
		begin
			out = in - 10'd556;
		end
		else if (in < 10'd834)
		begin
			out = in - 10'd695;
		end
		else if (in < 10'd973)
		begin
			out = in - 10'd834;
		end
		else
		begin
			out = in - 10'd973;
		end
	end
endmodule

module sum_stage_149 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1167
	always @ (posedge clk)
	begin
		out = in[7:0] + 107*in[8] + 65*in[9] + 130*in[10] + 111*in[11] + 73*in[12] + 146*in[13] + 143*in[14] + 137*in[15];
	end
endmodule

module correction_stage_149 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1167
	output reg [7:0] out; // Max value: 148
	wire [7:0] inter; // Max value: 148
	mod_149_1167 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_149_1167 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd149)
		begin
			out = in;
		end
		else if (in < 9'd298)
		begin
			out = in - 8'd149;
		end
		else if (in < 9'd447)
		begin
			out = in - 9'd298;
		end
		else if (in < 10'd596)
		begin
			out = in - 9'd447;
		end
		else if (in < 10'd745)
		begin
			out = in - 10'd596;
		end
		else if (in < 10'd894)
		begin
			out = in - 10'd745;
		end
		else if (in < 11'd1043)
		begin
			out = in - 10'd894;
		end
		else
		begin
			out = in - 11'd1043;
		end
	end
endmodule

module sum_stage_151 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 756
	always @ (posedge clk)
	begin
		out = in[7:0] + 105*in[8] + 59*in[9] + 118*in[10] + 85*in[11] + 19*in[12] + 38*in[13] + 76*in[14] + in[15];
	end
endmodule

module correction_stage_151 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 756
	output reg [7:0] out; // Max value: 150
	wire [7:0] inter; // Max value: 150
	mod_151_756 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_151_756 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd151)
		begin
			out = in;
		end
		else if (in < 9'd302)
		begin
			out = in - 8'd151;
		end
		else if (in < 9'd453)
		begin
			out = in - 9'd302;
		end
		else if (in < 10'd604)
		begin
			out = in - 9'd453;
		end
		else if (in < 10'd755)
		begin
			out = in - 10'd604;
		end
		else
		begin
			out = in - 10'd755;
		end
	end
endmodule

module sum_stage_157 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 694
	always @ (posedge clk)
	begin
		out = in[7:0] + 99*in[8] + 41*in[9] + 82*in[10] + 7*in[11] + 14*in[12] + 28*in[13] + 56*in[14] + 112*in[15];
	end
endmodule

module correction_stage_157 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 694
	output reg [7:0] out; // Max value: 156
	wire [7:0] inter; // Max value: 156
	mod_157_694 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_157_694 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd157)
		begin
			out = in;
		end
		else if (in < 9'd314)
		begin
			out = in - 8'd157;
		end
		else if (in < 9'd471)
		begin
			out = in - 9'd314;
		end
		else if (in < 10'd628)
		begin
			out = in - 9'd471;
		end
		else
		begin
			out = in - 10'd628;
		end
	end
endmodule

module sum_stage_163 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 661
	always @ (posedge clk)
	begin
		out = in[7:0] + 93*in[8] + 23*in[9] + 46*in[10] + 92*in[11] + 21*in[12] + 42*in[13] + 84*in[14] + 5*in[15];
	end
endmodule

module correction_stage_163 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 661
	output reg [7:0] out; // Max value: 162
	wire [7:0] inter; // Max value: 162
	mod_163_661 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_163_661 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd163)
		begin
			out = in;
		end
		else if (in < 9'd326)
		begin
			out = in - 8'd163;
		end
		else if (in < 9'd489)
		begin
			out = in - 9'd326;
		end
		else if (in < 10'd652)
		begin
			out = in - 9'd489;
		end
		else
		begin
			out = in - 10'd652;
		end
	end
endmodule

module sum_stage_167 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 572
	always @ (posedge clk)
	begin
		out = in[7:0] + 89*in[8] + 11*in[9] + 22*in[10] + 44*in[11] + 88*in[12] + 9*in[13] + 18*in[14] + 36*in[15];
	end
endmodule

module correction_stage_167 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 572
	output reg [7:0] out; // Max value: 166
	wire [7:0] inter; // Max value: 166
	mod_167_572 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_167_572 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd167)
		begin
			out = in;
		end
		else if (in < 9'd334)
		begin
			out = in - 8'd167;
		end
		else if (in < 9'd501)
		begin
			out = in - 9'd334;
		end
		else
		begin
			out = in - 9'd501;
		end
	end
endmodule

module sum_stage_173 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1179
	always @ (posedge clk)
	begin
		out = in[7:0] + 83*in[8] + 166*in[9] + 159*in[10] + 145*in[11] + 117*in[12] + 61*in[13] + 122*in[14] + 71*in[15];
	end
endmodule

module correction_stage_173 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1179
	output reg [7:0] out; // Max value: 172
	wire [7:0] inter; // Max value: 172
	mod_173_1179 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_173_1179 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd173)
		begin
			out = in;
		end
		else if (in < 9'd346)
		begin
			out = in - 8'd173;
		end
		else if (in < 10'd519)
		begin
			out = in - 9'd346;
		end
		else if (in < 10'd692)
		begin
			out = in - 10'd519;
		end
		else if (in < 10'd865)
		begin
			out = in - 10'd692;
		end
		else if (in < 11'd1038)
		begin
			out = in - 10'd865;
		end
		else
		begin
			out = in - 11'd1038;
		end
	end
endmodule

module sum_stage_179 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1095
	always @ (posedge clk)
	begin
		out = in[7:0] + 77*in[8] + 154*in[9] + 129*in[10] + 79*in[11] + 158*in[12] + 137*in[13] + 95*in[14] + 11*in[15];
	end
endmodule

module correction_stage_179 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1095
	output reg [7:0] out; // Max value: 178
	wire [7:0] inter; // Max value: 178
	mod_179_1095 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_179_1095 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd179)
		begin
			out = in;
		end
		else if (in < 9'd358)
		begin
			out = in - 8'd179;
		end
		else if (in < 10'd537)
		begin
			out = in - 9'd358;
		end
		else if (in < 10'd716)
		begin
			out = in - 10'd537;
		end
		else if (in < 10'd895)
		begin
			out = in - 10'd716;
		end
		else if (in < 11'd1074)
		begin
			out = in - 10'd895;
		end
		else
		begin
			out = in - 11'd1074;
		end
	end
endmodule

module sum_stage_181 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 918
	always @ (posedge clk)
	begin
		out = in[7:0] + 75*in[8] + 150*in[9] + 119*in[10] + 57*in[11] + 114*in[12] + 47*in[13] + 94*in[14] + 7*in[15];
	end
endmodule

module correction_stage_181 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 918
	output reg [7:0] out; // Max value: 180
	wire [7:0] inter; // Max value: 180
	mod_181_918 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_181_918 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd181)
		begin
			out = in;
		end
		else if (in < 9'd362)
		begin
			out = in - 8'd181;
		end
		else if (in < 10'd543)
		begin
			out = in - 9'd362;
		end
		else if (in < 10'd724)
		begin
			out = in - 10'd543;
		end
		else if (in < 10'd905)
		begin
			out = in - 10'd724;
		end
		else
		begin
			out = in - 10'd905;
		end
	end
endmodule

module sum_stage_191 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1168
	always @ (posedge clk)
	begin
		out = in[7:0] + 65*in[8] + 130*in[9] + 69*in[10] + 138*in[11] + 85*in[12] + 170*in[13] + 149*in[14] + 107*in[15];
	end
endmodule

module correction_stage_191 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1168
	output reg [7:0] out; // Max value: 190
	wire [7:0] inter; // Max value: 190
	mod_191_1168 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_191_1168 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd191)
		begin
			out = in;
		end
		else if (in < 9'd382)
		begin
			out = in - 8'd191;
		end
		else if (in < 10'd573)
		begin
			out = in - 9'd382;
		end
		else if (in < 10'd764)
		begin
			out = in - 10'd573;
		end
		else if (in < 10'd955)
		begin
			out = in - 10'd764;
		end
		else if (in < 11'd1146)
		begin
			out = in - 10'd955;
		end
		else
		begin
			out = in - 11'd1146;
		end
	end
endmodule

module sum_stage_193 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1073
	always @ (posedge clk)
	begin
		out = in[7:0] + 63*in[8] + 126*in[9] + 59*in[10] + 118*in[11] + 43*in[12] + 86*in[13] + 172*in[14] + 151*in[15];
	end
endmodule

module correction_stage_193 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1073
	output reg [7:0] out; // Max value: 192
	wire [7:0] inter; // Max value: 192
	mod_193_1073 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_193_1073 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd193)
		begin
			out = in;
		end
		else if (in < 9'd386)
		begin
			out = in - 8'd193;
		end
		else if (in < 10'd579)
		begin
			out = in - 9'd386;
		end
		else if (in < 10'd772)
		begin
			out = in - 10'd579;
		end
		else if (in < 10'd965)
		begin
			out = in - 10'd772;
		end
		else
		begin
			out = in - 10'd965;
		end
	end
endmodule

module sum_stage_197 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 919
	always @ (posedge clk)
	begin
		out = in[7:0] + 59*in[8] + 118*in[9] + 39*in[10] + 78*in[11] + 156*in[12] + 115*in[13] + 33*in[14] + 66*in[15];
	end
endmodule

module correction_stage_197 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 919
	output reg [7:0] out; // Max value: 196
	wire [7:0] inter; // Max value: 196
	mod_197_919 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_197_919 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd197)
		begin
			out = in;
		end
		else if (in < 9'd394)
		begin
			out = in - 8'd197;
		end
		else if (in < 10'd591)
		begin
			out = in - 9'd394;
		end
		else if (in < 10'd788)
		begin
			out = in - 10'd591;
		end
		else
		begin
			out = in - 10'd788;
		end
	end
endmodule

module sum_stage_199 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 860
	always @ (posedge clk)
	begin
		out = in[7:0] + 57*in[8] + 114*in[9] + 29*in[10] + 58*in[11] + 116*in[12] + 33*in[13] + 66*in[14] + 132*in[15];
	end
endmodule

module correction_stage_199 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 860
	output reg [7:0] out; // Max value: 198
	wire [7:0] inter; // Max value: 198
	mod_199_860 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_199_860 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd199)
		begin
			out = in;
		end
		else if (in < 9'd398)
		begin
			out = in - 8'd199;
		end
		else if (in < 10'd597)
		begin
			out = in - 9'd398;
		end
		else if (in < 10'd796)
		begin
			out = in - 10'd597;
		end
		else
		begin
			out = in - 10'd796;
		end
	end
endmodule

module sum_stage_211 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1180
	always @ (posedge clk)
	begin
		out = in[7:0] + 45*in[8] + 90*in[9] + 180*in[10] + 149*in[11] + 87*in[12] + 174*in[13] + 137*in[14] + 63*in[15];
	end
endmodule

module correction_stage_211 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1180
	output reg [7:0] out; // Max value: 210
	wire [7:0] inter; // Max value: 210
	mod_211_1180 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_211_1180 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd211)
		begin
			out = in;
		end
		else if (in < 9'd422)
		begin
			out = in - 8'd211;
		end
		else if (in < 10'd633)
		begin
			out = in - 9'd422;
		end
		else if (in < 10'd844)
		begin
			out = in - 10'd633;
		end
		else if (in < 11'd1055)
		begin
			out = in - 10'd844;
		end
		else
		begin
			out = in - 11'd1055;
		end
	end
endmodule

module sum_stage_223 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1088
	always @ (posedge clk)
	begin
		out = in[7:0] + 33*in[8] + 66*in[9] + 132*in[10] + 41*in[11] + 82*in[12] + 164*in[13] + 105*in[14] + 210*in[15];
	end
endmodule

module correction_stage_223 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1088
	output reg [7:0] out; // Max value: 222
	wire [7:0] inter; // Max value: 222
	mod_223_1088 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_223_1088 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd223)
		begin
			out = in;
		end
		else if (in < 9'd446)
		begin
			out = in - 8'd223;
		end
		else if (in < 10'd669)
		begin
			out = in - 9'd446;
		end
		else if (in < 10'd892)
		begin
			out = in - 10'd669;
		end
		else
		begin
			out = in - 10'd892;
		end
	end
endmodule

module sum_stage_227 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 613
	always @ (posedge clk)
	begin
		out = in[7:0] + 29*in[8] + 58*in[9] + 116*in[10] + 5*in[11] + 10*in[12] + 20*in[13] + 40*in[14] + 80*in[15];
	end
endmodule

module correction_stage_227 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 613
	output reg [7:0] out; // Max value: 226
	wire [7:0] inter; // Max value: 226
	mod_227_613 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_227_613 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd227)
		begin
			out = in;
		end
		else if (in < 9'd454)
		begin
			out = in - 8'd227;
		end
		else
		begin
			out = in - 9'd454;
		end
	end
endmodule

module sum_stage_229 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1186
	always @ (posedge clk)
	begin
		out = in[7:0] + 27*in[8] + 54*in[9] + 108*in[10] + 216*in[11] + 203*in[12] + 177*in[13] + 125*in[14] + 21*in[15];
	end
endmodule

module correction_stage_229 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1186
	output reg [7:0] out; // Max value: 228
	wire [7:0] inter; // Max value: 228
	mod_229_1186 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_229_1186 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd229)
		begin
			out = in;
		end
		else if (in < 9'd458)
		begin
			out = in - 8'd229;
		end
		else if (in < 10'd687)
		begin
			out = in - 9'd458;
		end
		else if (in < 10'd916)
		begin
			out = in - 10'd687;
		end
		else if (in < 11'd1145)
		begin
			out = in - 10'd916;
		end
		else
		begin
			out = in - 11'd1145;
		end
	end
endmodule

module sum_stage_233 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 994
	always @ (posedge clk)
	begin
		out = in[7:0] + 23*in[8] + 46*in[9] + 92*in[10] + 184*in[11] + 135*in[12] + 37*in[13] + 74*in[14] + 148*in[15];
	end
endmodule

module correction_stage_233 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 994
	output reg [7:0] out; // Max value: 232
	wire [7:0] inter; // Max value: 232
	mod_233_994 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_233_994 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd233)
		begin
			out = in;
		end
		else if (in < 9'd466)
		begin
			out = in - 8'd233;
		end
		else if (in < 10'd699)
		begin
			out = in - 9'd466;
		end
		else if (in < 10'd932)
		begin
			out = in - 10'd699;
		end
		else
		begin
			out = in - 10'd932;
		end
	end
endmodule

module sum_stage_239 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 766
	always @ (posedge clk)
	begin
		out = in[7:0] + 17*in[8] + 34*in[9] + 68*in[10] + 136*in[11] + 33*in[12] + 66*in[13] + 132*in[14] + 25*in[15];
	end
endmodule

module correction_stage_239 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 766
	output reg [7:0] out; // Max value: 238
	wire [7:0] inter; // Max value: 238
	mod_239_766 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_239_766 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd239)
		begin
			out = in;
		end
		else if (in < 9'd478)
		begin
			out = in - 8'd239;
		end
		else if (in < 10'd717)
		begin
			out = in - 9'd478;
		end
		else
		begin
			out = in - 10'd717;
		end
	end
endmodule

module sum_stage_241 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [10:0] out; // Max value: 1429
	always @ (posedge clk)
	begin
		out = in[7:0] + 15*in[8] + 30*in[9] + 60*in[10] + 120*in[11] + 240*in[12] + 239*in[13] + 237*in[14] + 233*in[15];
	end
endmodule

module correction_stage_241 (clk, in, out);
	input clk;
	input [10:0] in; // Max value: 1429
	output reg [7:0] out; // Max value: 240
	wire [7:0] inter; // Max value: 240
	mod_241_1429 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_241_1429 (in, out);
	input [10:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd241)
		begin
			out = in;
		end
		else if (in < 9'd482)
		begin
			out = in - 8'd241;
		end
		else if (in < 10'd723)
		begin
			out = in - 9'd482;
		end
		else if (in < 10'd964)
		begin
			out = in - 10'd723;
		end
		else if (in < 11'd1205)
		begin
			out = in - 10'd964;
		end
		else
		begin
			out = in - 11'd1205;
		end
	end
endmodule

module sum_stage_251 (clk, in, out);
	input clk;
	input [15:0] in; // Max value: 65535
	output reg [9:0] out; // Max value: 777
	always @ (posedge clk)
	begin
		out = in[7:0] + 5*in[8] + 10*in[9] + 20*in[10] + 40*in[11] + 80*in[12] + 160*in[13] + 69*in[14] + 138*in[15];
	end
endmodule

module correction_stage_251 (clk, in, out);
	input clk;
	input [9:0] in; // Max value: 777
	output reg [7:0] out; // Max value: 250
	wire [7:0] inter; // Max value: 250
	mod_251_777 inst(in, inter);
	always @ (posedge clk)
	begin
		out = inter;
	end
endmodule

module mod_251_777 (in, out);
	input [9:0] in;
	output reg [7:0] out;
	always @ (in)
	begin
		if (in < 8'd251)
		begin
			out = in;
		end
		else if (in < 9'd502)
		begin
			out = in - 8'd251;
		end
		else if (in < 10'd753)
		begin
			out = in - 9'd502;
		end
		else
		begin
			out = in - 10'd753;
		end
	end
endmodule
